import * as asyncHandler from 'express-async-handler';
import * as fuhuaqiBiz from '../biz/fuHuqQi/user';
import * as monthBiz from '../biz/fuHuqQi/month';

export function setRouter(httpServer) {
    httpServer.post('/fuhuaqi/login', asyncHandler(login));
    httpServer.post('/fuhuaqi/home', asyncHandler(homeInfo));
    httpServer.post('/fuhuaqi/task', asyncHandler(taskInfo));
    httpServer.post('/fuhuaqi/task/addtask', asyncHandler(addTask));
    httpServer.post('/fuhuaqi/mydata', asyncHandler(myDataInfo));
    httpServer.post('/fuhuaqi/mydata/update', asyncHandler(updateMyDataInfo));
    httpServer.post('/fuhuaqi/month/addreport', asyncHandler(addReport));
}

/**
 * 孵化器登录 
 * @param req 获取请求中的body内容
 * @param res 
 */
async function login(req, res) {
    let { uscc, pwd } = req.body;
    let result = await fuhuaqiBiz.login(uscc, pwd);
    res.success(result);
}

/**
 * 主界面信息 
 * 包括首页的 我的数据 评分明细
 * @param req 
 * @param res 
 */
async function homeInfo(req, res) {
    
    res.success({});
}

/**
 * 任务中心
 * @param req 
 * @param res 
 */
async function taskInfo(req, res) {
    
    res.success({});
}

/**
 * 新增报表
 * @param req 
 * @param res 
 */
async function addTask(req, res) {
    
    res.success({});
}



/**
 * 我的数据 详细数据
 * @param req 
 * @param res 
 */
async function myDataInfo(req, res) {
    
    res.success({});
}

/**
 * 更新我的数据
 * @param req 
 * @param res 
 */
async function updateMyDataInfo(req, res) {
    
    res.success({});
}

/**
 * 孵化月度填报 新增报表
 * @param req 
 * @param res 
 */
async function addReport(req, res) {
    let {fuHuaQiUscc, occupancyRate} = req.body;
    let monthInfo = monthBiz.createReport(fuHuaQiUscc, occupancyRate)
    res.success(monthInfo);
}